'--------------------------------------------------------------------------------
'  ExternalIP.vbs (v1.4)
'--------------------------------------------------------------------------------
'
' Retreives your external IP address from http://checkip.dyndns.org/ (this is
' useful for computers behind routers and firewalls)
'
' Changes in v1.4 by Nilfred :-)
'
' - Added function parametes for router(s) specific URL and password
' - Added D-Link DI-604 router
' - Added some variable declarations
' - Speed improvements in InStr function
' - Removal of erroneous -1 offset of rightMark
' - Fixed checkip.dyndns.org small change to their web page
'
' Changes in v1.3
'
' - international version returns 2 IP addresses if you have multiple NICs in your
'   computer - fixed to only show one. (Thanks Rasman)
'
' Changes in v1.2
'
' - uses new URL to save bandwidth
' - Old script was actually returning proxy IP, not actual IP!
'
' Changes in v1.1:
'
' - Added error messages
' - Hid relevant functions from Samurize 0.85b
'
'								-NeM
'--------------------------------------------------------------------------------

Function getExternalIP (Router, RouterIP, userPassword)

	Dim htmlResult
	Dim leftMark, rightMark

	Select Case Router
	Case "DI-604"
		htmlResult = ReturnHTML("http://user:" & userPassword & "@" & RouterIP & "/st_devic.html")

		leftMark = instr(htmlResult, "2>IP" ) + 103

		rightMark = instr( leftMark, htmlResult, vbCRLF)
	Case Else
		htmlResult = ReturnHTML("http://checkip.dyndns.org/")

		leftMark = instr(htmlResult, "Address: " ) + 9

		if Instr( leftMark, htmlResult, ",") > 0 Then
			rightMark = instr( leftMark, htmlResult, ",")
		else
			rightMark = instr( leftMark, htmlResult, "<")
		End If
	End Select

	if rightMark > 0 Then

		'grabs the IP
		getExternalIP = Mid( htmlResult, leftMark, rightMark - leftMark )

	else
		getExternalIP = "ERROR"

	end if

End Function

Private Function ReturnHTML(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	HTML = objXMLHTTP.responseBody
	Set objRS = CreateObject("ADODB.Recordset")
	objRS.Fields.Append "txt", 200, 45000, &H00000080
	objRS.Open
	objRS.AddNew
	objRS.Fields("txt").AppendChunk HTML
	ReturnHTML = objRS("txt").Value
	objRS.Close
	Set objRS = Nothing
	Set objXMLHTTP = Nothing

End Function
